#ifndef	PEXEXTPROTO_H
#define	PEXEXTPROTO_H

/* Common Open Systems Environment, Common Graphics Environment  */		
/* Extension to PEX 5.1 version 2.  File date: March 30, 1994    */		

/******************************************************************************/
/*  (c)	Copyright Hewlett-Packard Company, 1993,  Fort Collins,	Colorado      */
/*									      */
/*  (C)	COPYRIGHT International	Business Machines Corp.	1993		      */
/*									      */
/*   Copyright (c) 1993	by Sun Microsystems, Inc.			      */
/*									      */
/*			      All Rights Reserved			      */
/*									      */
/*  Permission to use, copy, modify, and distribute this software and its     */
/*  documentation for any purpose and without fee is hereby granted,	      */
/*  provided that the above copyright notices appear in	all copies and that   */
/*  both the copyright notices and this	permission notice appear in	      */
/*  supporting documentation, and that the names of Hewlett-Packard,	      */
/*  International Business Machines, or	Sun Microsystems not be	used in	      */
/*  advertising	or publicity pertaining	to distribution	of the software	      */
/*  without specific, written prior permission.				      */
/*									      */
/*  HEWLETT-PACKARD MAKES NO WARRANTY OF ANY KIND WITH REGARD TO THIS	      */
/*  SOFTWARE, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF	      */
/*  MERCHANTABILITY AND	FITNESS	FOR A PARTICULAR PURPOSE.  Hewlett-Packard    */
/*  shall not be liable	for errors contained herein or direct, indirect,      */
/*  special, incidental	or consequential damages in connection with the	      */
/*  furnishing,	performance or use of this software.			      */
/*									      */
/*  INTERNATIONAL BUSINESS MACHINES CORPORATION	PROVIDES THIS MATERIAL	      */
/*  "AS	IS" WITHOUT WARRANTY OF	ANY KIND, EITHER EXPRESSED OR IMPLIED,	      */
/*  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY  */
/*  AND	FITNESS	FOR A PARTICULAR PURPOSE.				      */
/*									      */
/*  SUN	MICROSYSTEMS, INC. DISCLAIMS ALL WARRANTIES WITH REGARD	TO THIS	      */
/*  SOFTWARE, INCLUDING	ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS,*/
/*  IN NO EVENT	SHALL SUN MICROSYSTEMS,	INC. BE	LIABLE FOR ANY SPECIAL,	      */
/*  INDIRECT OR	CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER	RESULTING     */
/*  FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT,      */
/*  NEGLIGENCE OR OTHER	TORTIOUS ACTION, ARISING OUT OF	OR IN CONNECTION      */
/*  WITH THE USE OR PERFORMANCE	OF THIS	SOFTWARE.			      */
/*									      */
/******************************************************************************/

#include <X11/PEX5/PEXExtprotost.h>
 
/****************************************************************
 *		Ext REPLIES					*
 ****************************************************************/

typedef	struct {
    /* no X_Reply info - request implemented with PEXEscape */	  
    BYTE	pad[20];
    /* SINGLE ExtPipelineContextAttributes( itemMask )	*/
    } pexExtGetPipelineContextReply;

typedef	struct {
    /* no X_Reply info - request implemented with PEXEscape */	  
    BYTE	pad[20];
    /* SINGLE ExtRendererAttributes( itemMask )	*/
    } pexExtGetRendererAttributesReply;

typedef	struct {
    /* no X_Reply info - request implemented with PEXEscape */	  
    CARD16	status B16;
    CARD16	tableType B16;
    BYTE	pad[16];
    /* SINGLE TableEntry( tableType )  */
    } pexExtGetTableEntryReply;

typedef	struct {
    /* no X_Reply info - request implemented with PEXEscape */	  
    CARD16	tableType B16;
    CARD16	unused B16;
    CARD32	numEntries B32;
    BYTE	pad[12];
    /* LISTof TableEntry( numEntries, tableType	) */
    } pexExtGetTableEntriesReply;

typedef	struct {
    /* no X_Reply info - request implemented with PEXEscape */	  
    CARD32	numElements B32;
    BYTE	pad[16];
    /* LISTof OutputCommand( numElements ) */
    } pexExtFetchElementsReply;

/****************************************************************
 *		Ext REQUESTS					*
 ****************************************************************/

/*****************************************************************
 *  Ext	Specific Requests 
 *	 NOTE: these are all implemented as PEXEscapes
 *****************************************************************/

typedef	struct {
    /* no reqType, opcode, length - request implemented	with PEXEscape */    
    pexEnumTypeIndex	fpFormat B16;
    CARD16		unused B16;
    pexPC		pc B32;
    pexBitmask		itemMask0 B32;
    pexBitmask		itemMask1 B32;
    pexBitmask		itemMask2 B32;
} pexExtGetPipelineContextReq;

typedef	struct {
    /* no reqType, opcode, length -request implemented with PEXEscape */    
    pexEnumTypeIndex	fpFormat B16;
    CARD16		unused B16;
    pexPC		pc B32;
    pexBitmask		itemMask0 B32;
    pexBitmask		itemMask1 B32;
    pexBitmask		itemMask2 B32;
    /* SINGLE ExtPipelineContextAttributes( itemMask ) */
} pexExtChangePipelineContextReq;

typedef	struct {
    /* no reqType, opcode, length -request implemented with PEXEscape */    
    pexEnumTypeIndex	fpFormat B16;
    CARD16		unused B16;
    pexRenderer		rdr B32;
    pexBitmask		itemMask0 B32;
    pexBitmask		itemMask1 B32;
    /* SINGLE ExtRendererAttributes( itemMask )	*/
} pexExtChangeRendererReq;

typedef	struct {
    /* no reqType, opcode, length -request implemented with PEXEscape */    
    pexEnumTypeIndex	fpFormat B16;
    CARD16		unused B16;
    pexRenderer		rdr B32;
    pexBitmask		itemMask0 B32;
    pexBitmask		itemMask1 B32;
} pexExtGetRendererAttributesReq;

typedef	struct {
    /* no reqType, opcode, length -request implemented with PEXEscape */    
    pexEnumTypeIndex	fpFormat B16;
    CARD16		valueType B16;
    pexLookupTable	lut B32;
    pexTableIndex	index B16;
    CARD16		pad B16;
} pexExtGetTableEntryReq;

typedef	struct {
    /* no reqType, opcode, length -request implemented with PEXEscape */    
    pexEnumTypeIndex	fpFormat B16;
    CARD16		valueType B16;
    pexLookupTable	lut B32;
    pexTableIndex	start B16;
    CARD16		count B16;
} pexExtGetTableEntriesReq;

typedef	struct {
    /* no reqType, opcode, length -request implemented with PEXEscape */    
    pexEnumTypeIndex	fpFormat B16;
    CARD16		unused B16;
    pexLookupTable	lut B32;
    pexTableIndex	start B16;
    CARD16		count B16;
/*    LISTof TableEntry( count ) */
} pexExtSetTableEntriesReq;

typedef	struct {
    /* no reqType, opcode, length -request implemented with PEXEscape */    
    pexEnumTypeIndex	fpFormat B16;
    CARD16		unused B16;
    pexStructure	sid B32;
    CARD16		position1_whence B16;
    CARD16		unused1	B16;
    INT32		position1_offset B32;
    CARD16		position2_whence B16;
    CARD16		unused2	B16;
    INT32		position2_offset B32;
} pexExtFetchElementsReq;

/*****************************************************************
 * Ext Output Commands 
 *****************************************************************/

typedef	struct {
    CARD16		oc_opcode B16;
    CARD16		oc_length B16;
    pexEnumTypeIndex	correction B16;
    CARD16		pad B16;
} pexExtTMPerspectiveCorrection;

typedef	struct {
    CARD16		oc_opcode B16;
    CARD16		oc_length B16;
    pexEnumTypeIndex	sampleFrequency	B16;
    CARD16		pad B16;
} pexExtTMSampleFrequency;     

typedef	struct {
    CARD16		oc_opcode B16;
    CARD16		oc_length B16;
    INT16		optimization B16;
    CARD16		numIndex B16;
    /* LISTof pexTableIndex( numIndex )	*/
    /* pad( ( numIndex )*2 ) */
} pexExtTMResourceHints;

typedef	struct {
    CARD16		oc_opcode B16;
    CARD16		oc_length B16;
    pexEnumTypeIndex	mode B16;
    pexEnumTypeIndex	blend_op B16;
} pexExtPrimitiveAA;

typedef	struct {
    CARD16		oc_opcode B16;
    CARD16		oc_length B16;
    pexEnumTypeIndex	style B16;
    CARD16		pad B16;
} pexExtLineCap;

typedef	struct {
    CARD16		oc_opcode B16;
    CARD16		oc_length B16;
    pexEnumTypeIndex	style B16;
    CARD16		pad B16;
} pexExtLineJoin;

typedef	struct {
    CARD16		oc_opcode B16;
    CARD16		oc_length B16;
    CARD16		numIndex B16;
    CARD16		pad B16;
    /* LISTof pexTableIndex( numIndex )	*/
    /* pad( ( numIndex )*2 ) */
} pexExtActiveTextures;

typedef	pexExtActiveTextures pexExtBFActiveTextures;

typedef	struct {
    CARD16		oc_opcode B16;
    CARD16		oc_length B16;
    CARD16		shape B16;
    pexSwitch		ignoreEdges;
    CARD8		contourHint;
    pexColorType	colorType B16;
    pexBitmaskShort	facetAttribs B16;
    pexBitmaskShort	vertexAttribs B16;
    CARD16		numVertexFPData	B16;
    CARD32		numLists B32;
    /* pexOptData( facetAttribs	) */
    /* LISTof CLISTof  pexVertex( numLists, vertexAttribs,	    */
    /*			       colorType, numVertexFPData)	    */
} pexExtFillAreaSetWithData;

typedef	struct {
    CARD16		oc_opcode B16;
    CARD16		oc_length B16;
    pexColorType	colorType B16;
    pexBitmaskShort	facetAttribs B16;
    pexBitmaskShort	vertexAttribs B16;
    CARD16		numVertexFPData	B16;
    CARD32		numVertices B32;
    /* number of OptData is numVert - 2	*/
    /* LISTof pexOptData( facetAttribs,	colorType ) */
    /* LISTof pexVertex( numVertices, vertexAttribs, colorType */
    /*			 numVertexFPData )		       */
} pexExtTriangleStrip;

typedef	struct {
    CARD16		oc_opcode B16;
    CARD16		oc_length B16;
    pexColorType	colorType B16;
    CARD16		mPts B16;
    CARD16		nPts B16;
    pexBitmaskShort	facetAttribs B16;
    pexBitmaskShort	vertexAttribs B16;
    CARD16		numVertexFPData	B16;
    CARD16		shape B16;
    CARD16		unused B16;
    /* actually, there are (mPts-1)*(nPts-1) opt data entries */
    /* LISTof pexOptData( facetAttribs,	colorType ) */
    /* LISTof pexVertex( mPts, nPts, vertexAttribs, colorType  */
    /*			 numVertexFPData )		       */ 
} pexExtQuadrilateralMesh;

typedef	struct {
    CARD16		oc_opcode B16;
    CARD16		oc_length B16;
    CARD16		shape B16;
    pexColorType	colorType B16;
    CARD16		FAS_Attributes B16;
    CARD16		vertexAttributes B16;
    CARD16		edgeAttributes B16;
    CARD16		numVertexFPData	B16;
    CARD8		contourHint;
    pexSwitch		contourCountsFlag;
    CARD16		numFAS B16;
    CARD16		numVertices B16;
    CARD16		numEdges B16;
    CARD16		numContours B16;
    CARD16		unused B16;
    /* LISTof OPT_DATA(	numFAS ) */
    /* LISTof pexVertex( numVertices, vertexAttributes,	colorType, */
    /*			 numVertexFPData )			   */ 
    /* LISTof CARD8( numEdges )	*/
    /* pad( numEdges ) */
    /* LISTof CLISTof CLISTof CARD16( numFAS, numContours, numEdges ) */
    /* pad */
} pexExtSetOfFillAreaSets;

typedef	struct {
    CARD16		oc_opcode B16;
    CARD16		oc_length B16;
    PEXFLOAT		center_x B32;
    PEXFLOAT		center_y B32;
    PEXFLOAT		center_z B32;
    PEXFLOAT		major_x	B32;
    PEXFLOAT		major_y	B32;
    PEXFLOAT		major_z	B32;
    PEXFLOAT		minor_x	B32;
    PEXFLOAT		minor_y	B32;
    PEXFLOAT		minor_z	B32;
} pexExtEllipse;

typedef	struct {
    CARD16		oc_opcode B16;
    CARD16		oc_length B16;
    PEXFLOAT		center_x B32;
    PEXFLOAT		center_y B32;
    PEXFLOAT		center_z B32;
    PEXFLOAT		major_x	B32;
    PEXFLOAT		major_y	B32;
    PEXFLOAT		major_z	B32;
    PEXFLOAT		minor_x	B32;
    PEXFLOAT		minor_y	B32;
    PEXFLOAT		minor_z	B32;
    PEXFLOAT		start_angle B32;
    PEXFLOAT		stop_angle B32;
} pexExtEllipticalArc;

typedef	struct {
    CARD16		oc_opcode B16;
    CARD16		oc_length B16;
    PEXFLOAT		center_x B32;
    PEXFLOAT		center_y B32;
    PEXFLOAT		major_x	B32;
    PEXFLOAT		major_y	B32;
    PEXFLOAT		minor_x	B32;
    PEXFLOAT		minor_y	B32;
    PEXFLOAT		start_angle B32;
    PEXFLOAT		stop_angle B32;
} pexExtEllipticalArc2D;

typedef	struct {
    CARD16		oc_opcode B16;
    CARD16		oc_length B16;
    PEXFLOAT		center_x B32;	
    PEXFLOAT		center_y B32;
    PEXFLOAT		major_x	B32;
    PEXFLOAT		major_y	B32;
    PEXFLOAT		minor_x	B32;
    PEXFLOAT		minor_y	B32;
} pexExtEllipse2D;

typedef	struct {
    CARD16		oc_opcode B16;
    CARD16		oc_length B16;
    PEXFLOAT		center_x B32;	
    PEXFLOAT		center_y B32;
    PEXFLOAT		radius B32;
} pexExtCircle2D;

typedef	struct {
    CARD16		oc_opcode B16;
    CARD16		oc_length B16;
    PEXFLOAT		center_x B32;	
    PEXFLOAT		center_y B32;
    PEXFLOAT		radius B32;
    PEXFLOAT		start_angle B32;
    PEXFLOAT		stop_angle B32;
} pexExtCircularArc2D;

typedef	struct {
    CARD16		oc_opcode B16;
    CARD16		oc_length B16;
    CARD32		numBytes B32;
    /* LISTof CARD8( numBytes )	-- don't swap */
    /* pad( numBytes ) */
} pexExtVendorExtOC;

#endif /* PEXEXTPROTO_H	*/

