
/* Common Open Systems Environment, Common Graphics Environment	 */		
/* Extension to	PEX 5.1	version	2.  File date: February	10, 1994 */		

/******************************************************************************/
/*  (c)	Copyright Hewlett-Packard Company, 1993,  Fort Collins,	Colorado      */
/*									      */
/*  (C)	COPYRIGHT International	Business Machines Corp.	1993		      */
/*									      */
/*   Copyright (c) 1993	by Sun Microsystems, Inc.			      */
/*									      */
/*			      All Rights Reserved			      */
/*									      */
/*  Permission to use, copy, modify, and distribute this software and its     */
/*  documentation for any purpose and without fee is hereby granted,	      */
/*  provided that the above copyright notices appear in	all copies and that   */
/*  both the copyright notices and this	permission notice appear in	      */
/*  supporting documentation, and that the names of Hewlett-Packard,	      */
/*  International Business Machines, or	Sun Microsystems not be	used in	      */
/*  advertising	or publicity pertaining	to distribution	of the software	      */
/*  without specific, written prior permission.				      */
/*									      */
/*  HEWLETT-PACKARD MAKES NO WARRANTY OF ANY KIND WITH REGARD TO THIS	      */
/*  SOFTWARE, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF	      */
/*  MERCHANTABILITY AND	FITNESS	FOR A PARTICULAR PURPOSE.  Hewlett-Packard    */
/*  shall not be liable	for errors contained herein or direct, indirect,      */
/*  special, incidental	or consequential damages in connection with the	      */
/*  furnishing,	performance or use of this software.			      */
/*									      */
/*  INTERNATIONAL BUSINESS MACHINES CORPORATION	PROVIDES THIS MATERIAL	      */
/*  "AS	IS" WITHOUT WARRANTY OF	ANY KIND, EITHER EXPRESSED OR IMPLIED,	      */
/*  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY  */
/*  AND	FITNESS	FOR A PARTICULAR PURPOSE.				      */
/*									      */
/*  SUN	MICROSYSTEMS, INC. DISCLAIMS ALL WARRANTIES WITH REGARD	TO THIS	      */
/*  SOFTWARE, INCLUDING	ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS,*/
/*  IN NO EVENT	SHALL SUN MICROSYSTEMS,	INC. BE	LIABLE FOR ANY SPECIAL,	      */
/*  INDIRECT OR	CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER	RESULTING     */
/*  FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT,      */
/*  NEGLIGENCE OR OTHER	TORTIOUS ACTION, ARISING OUT OF	OR IN CONNECTION      */
/*  WITH THE USE OR PERFORMANCE	OF THIS	SOFTWARE.			      */
/*									      */
/******************************************************************************/


 /* =======================================================================
  * NOTE NOTE NOTE  Insert this	section
  *		    at the end of pl_oc_enc.c file
  * ====================================================================='=
  */

/***** Start of	Ext section ************/

#include "PEXExtlib.h"
#include "PEXExtlibint.h"


char *
PEXExtEncodeOCs	(float_format, oc_count, oc_data, length_return)

INPUT int		float_format;
INPUT unsigned long	oc_count;
INPUT PEXExtOCData	*oc_data;
OUTPUT unsigned	long	*length_return;

{
    extern void		(*(PEX_encode_oc_funcs[]))();
    extern void		(*(PEXExt_encode_oc_funcs[]))();
    PEXExtOCData	*ocSrc;
    char		*ocDest, *ocRet;
    int			i;


    /*
     * Allocate	a buffer to hold the encodings.
     */

    *length_return = PEXExtGetSizeOCs (float_format, oc_count, oc_data);
    ocRet = ocDest = (char *) PEXAllocBuf (*length_return);


    /*
     * Now, encode the OCs in the buffer.  Use either the standard
     * table of	encode functions, the Ext table	or call	the default
     * Ext encode function.					    
     */

    for	(i = 0,	ocSrc =	oc_data; i < oc_count; i++, ocSrc++)
	if ( (short) ocSrc->oc_type >= 0	 &&
	     (short) ocSrc->oc_type <= PEXOCNoop   )
	{
	    (*PEX_encode_oc_funcs[ocSrc->oc_type]) 
		(float_format, ocSrc, &ocDest);
	}

	else if	( (short) ocSrc->oc_type >= PEXExtOCMin	&&
		  (short) ocSrc->oc_type <= PEXExtOCMax	  )
	{
	    (*PEXExt_encode_oc_funcs
		[ocSrc->oc_type	- (unsigned short) PEXExtOCMin])	
		(float_format, ocSrc, &ocDest);
	}

	else
	{
	    (_PEXExtEncodeVendorExtOC) 
		(ocSrc,	&ocDest);
	}

#ifdef DEBUG
    if (ocDest - ocRet != *length_return)
    {
	printf ("PEXlib	WARNING	: Internal error in PEXExtEncodeOCs :\n");
	printf ("Data size encoded != Data size	allocated.\n");
    }
#endif

    return (ocRet);
}


void _PEXExtEncodeEnumType (fpFormat, ocSrc, ocDest)
int		fpFormat;
PEXExtOCData	*ocSrc;
char		**ocDest;

{
    pexExtTMPerspectiveCorrection	*oc;

    BEGIN_SIMPLE_ENCODE	(ExtTMPerspectiveCorrection, ocSrc->oc_type, 
	*ocDest, oc);

    oc->correction = ocSrc->data.ExtSetTMPerspectiveCorrection.method;	  
    
    END_SIMPLE_ENCODE (ExtTMPerspectiveCorrection, *ocDest, oc);
}


void _PEXExtEncodeTMResourceHints (fpFormat, ocSrc, ocDest)

int		fpFormat;
PEXExtOCData	*ocSrc;
char		**ocDest;

{
    pexExtTMResourceHints	*oc;
    int			dataLength;

    dataLength =
	NUMWORDS (SIZEOF (CARD16) * 
	ocSrc->data.ExtSetTMResourceHints.count); 

    BEGIN_ENCODE_OCHEADER (ExtTMResourceHints, ocSrc->oc_type,
	dataLength, *ocDest, oc);

    oc->optimization = ocSrc->data.ExtSetTMResourceHints.optimization;
    oc->numIndex = ocSrc->data.ExtSetTMResourceHints.count;

    END_ENCODE_OCHEADER	(ExtTMResourceHints, *ocDest, oc);

    STORE_LISTOF_CARD16	(ocSrc->data.ExtSetTMResourceHints.count,
	ocSrc->data.ExtSetTMResourceHints.priorities, *ocDest);

    if (ocSrc->data.ExtSetTMResourceHints.count	& 1)
	*ocDest	+= 2;
}


void _PEXExtEncodeActiveTextures (fpFormat, ocSrc, ocDest)

int		fpFormat;
PEXExtOCData	*ocSrc;
char		**ocDest;

{
    pexExtActiveTextures	*oc;
    int			dataLength;

    dataLength =
	NUMWORDS (SIZEOF (CARD16) * 
	ocSrc->data.ExtSetActiveTextures.count); 

    BEGIN_ENCODE_OCHEADER (ExtActiveTextures, ocSrc->oc_type,
	dataLength, *ocDest, oc);

    oc->numIndex = ocSrc->data.ExtSetActiveTextures.count;

    END_ENCODE_OCHEADER	(ExtActiveTextures, *ocDest, oc);

    STORE_LISTOF_CARD16	(ocSrc->data.ExtSetActiveTextures.count,
	ocSrc->data.ExtSetActiveTextures.textures, *ocDest);

    if (ocSrc->data.ExtSetActiveTextures.count & 1)
	*ocDest	+= 2;
}


void _PEXExtEncodeFillAreaSetWithData (fpFormat, ocSrc,	ocDest)

int		fpFormat;
PEXExtOCData	*ocSrc;
char		**ocDest;

{
    pexExtFillAreaSetWithData	*oc;
    int				dataLength;
    int				lenofColor;
    int				lenofFacet;
    int				lenofVertex;
    int				numVertices, i;
    int				colorType;
    int				vertexFPDataSize;
    unsigned int		numFillAreas;
    unsigned int		facetAttributes;
    unsigned int		vertexAttributes;
    PEXExtListOfVertex		*vertices;
    int				fpConvert = (fpFormat != NATIVE_FP_FORMAT);
    
    colorType =	ocSrc->data.ExtFillAreaSetWithData.color_type;
    vertexFPDataSize = ocSrc->data.ExtFillAreaSetWithData.vertex_fp_data_size;
    numFillAreas = ocSrc->data.ExtFillAreaSetWithData.count;
    facetAttributes = ocSrc->data.ExtFillAreaSetWithData.facet_attributes;
    vertexAttributes = ocSrc->data.ExtFillAreaSetWithData.vertex_attributes;
    vertices = ocSrc->data.ExtFillAreaSetWithData.vertex_lists;
    
    lenofColor = GetColorLength	(colorType);
    lenofFacet = GetFacetDataLength (facetAttributes, lenofColor); 
    lenofVertex	= GetVertexWithDataLength (vertexAttributes, lenofColor);
    
    if (vertexAttributes & PEXGAEdges)
	lenofVertex++;			/* edge	switch is CARD32 */

    if (vertexAttributes & PEXExtGAData)
	lenofVertex += NUMWORDS	(vertexFPDataSize * SIZEOF (PEXFLOAT));
    
    for	(i = 0,	numVertices = 0; i < numFillAreas; i++)
	numVertices += vertices[i].count;
    
    dataLength = lenofFacet + numFillAreas + numVertices * lenofVertex;

    BEGIN_ENCODE_OCHEADER (ExtFillAreaSetWithData, ocSrc->oc_type,
	dataLength, *ocDest, oc);

    oc->shape =	ocSrc->data.ExtFillAreaSetWithData.shape_hint;
    oc->ignoreEdges = ocSrc->data.ExtFillAreaSetWithData.ignore_edges;
    oc->contourHint = ocSrc->data.ExtFillAreaSetWithData.contour_hint;
    oc->colorType = colorType;
    oc->facetAttribs = facetAttributes;
    oc->vertexAttribs =	vertexAttributes;
    oc->numVertexFPData	= vertexFPDataSize;
    oc->numLists = numFillAreas;
    
    END_ENCODE_OCHEADER	(ExtFillAreaSetWithData, *ocDest, oc);

    if (facetAttributes)
    {
	STORE_FACET (colorType,	facetAttributes,
	    ocSrc->data.ExtFillAreaSetWithData.facet_data, *ocDest,
	    fpConvert, fpFormat);
    }
    
    for	(i = 0;	i < numFillAreas; i++)
    {
	STORE_CARD32 (vertices[i].count, *ocDest);
	
	STORE_LISTOF_EXT_VERTEX	(vertices[i].count, NUMBYTES (lenofVertex),
	    colorType, vertexFPDataSize,
	    vertexAttributes, vertices[i].vertices, *ocDest,
	    fpConvert, fpFormat);
    }
}


void _PEXExtEncodeTriangleStrip	(fpFormat, ocSrc, ocDest)

int		fpFormat;
PEXExtOCData	*ocSrc;
char		**ocDest;

{
    pexExtTriangleStrip	*oc;
    int			dataLength;
    int			lenofColor;
    int			lenofFacet;
    int			lenofVertex;
    int			colorType;
    int			vertexFPDataSize;
    unsigned long	numVertices;
    unsigned int	facetAttributes;
    unsigned int	vertexAttributes;
    int			fpConvert = (fpFormat != NATIVE_FP_FORMAT);
    
    colorType =	ocSrc->data.ExtTriangleStrip.color_type;
    vertexFPDataSize = ocSrc->data.ExtTriangleStrip.vertex_fp_data_size;
    numVertices	= ocSrc->data.ExtTriangleStrip.count;
    facetAttributes = ocSrc->data.ExtTriangleStrip.facet_attributes;
    vertexAttributes = ocSrc->data.ExtTriangleStrip.vertex_attributes;
    
    lenofColor = GetColorLength	(colorType);
    lenofFacet = GetFacetDataLength (facetAttributes, lenofColor); 
    lenofVertex	= GetVertexWithDataLength (vertexAttributes, lenofColor);

    if (vertexAttributes & PEXExtGAData)
	lenofVertex += NUMWORDS	(vertexFPDataSize * SIZEOF (PEXFLOAT));

    dataLength = (numVertices -	2) * lenofFacet	+ numVertices *	lenofVertex;

    BEGIN_ENCODE_OCHEADER (ExtTriangleStrip, ocSrc->oc_type,
	dataLength, *ocDest, oc);

    oc->colorType = colorType;
    oc->numVertexFPData	= vertexFPDataSize;
    oc->facetAttribs = facetAttributes;
    oc->vertexAttribs =	vertexAttributes;
    oc->numVertices = numVertices;
    
    END_ENCODE_OCHEADER	(ExtTriangleStrip, *ocDest, oc);

    if (facetAttributes)
    {
	STORE_LISTOF_FACET ((numVertices - 2),
		NUMBYTES (lenofFacet), colorType,
	    facetAttributes, ocSrc->data.ExtTriangleStrip.facet_data,
	    *ocDest, fpConvert,	fpFormat);
    }
    
    STORE_LISTOF_EXT_VERTEX (numVertices, NUMBYTES (lenofVertex), colorType,
	vertexFPDataSize,
	vertexAttributes, ocSrc->data.ExtTriangleStrip.vertices, *ocDest,
	fpConvert, fpFormat);
}


void _PEXExtEncodeQuadMesh (fpFormat, ocSrc, ocDest)

int		fpFormat;
PEXExtOCData	*ocSrc;
char		**ocDest;

{
    pexExtQuadrilateralMesh	*oc;
    int				dataLength;
    int				lenofColor;
    int				lenofFacet;
    int				lenofVertex;
    int				colorType;
    int				vertexFPDataSize;
    unsigned int		rowCount;
    unsigned int		colCount;
    unsigned int		facetAttributes;
    unsigned int		vertexAttributes;
    int				fpConvert = (fpFormat != NATIVE_FP_FORMAT);
    
    colorType =	ocSrc->data.ExtQuadrilateralMesh.color_type;
    vertexFPDataSize = ocSrc->data.ExtQuadrilateralMesh.vertex_fp_data_size;
    rowCount = ocSrc->data.ExtQuadrilateralMesh.row_count;
    colCount = ocSrc->data.ExtQuadrilateralMesh.col_count;
    facetAttributes = ocSrc->data.ExtQuadrilateralMesh.facet_attributes;
    vertexAttributes = ocSrc->data.ExtQuadrilateralMesh.vertex_attributes;
    
    lenofColor = GetColorLength	(colorType);
    lenofFacet = GetFacetDataLength (facetAttributes, lenofColor); 
    lenofVertex	= GetVertexWithDataLength (vertexAttributes, lenofColor);

    if (vertexAttributes & PEXExtGAData)
	lenofVertex += NUMWORDS	(vertexFPDataSize * SIZEOF (PEXFLOAT));

    dataLength = (((rowCount - 1) * (colCount -	1)) * lenofFacet) +
	(rowCount * colCount * lenofVertex);

    BEGIN_ENCODE_OCHEADER (ExtQuadrilateralMesh, ocSrc->oc_type,
	dataLength, *ocDest, oc);
    
    oc->colorType = colorType;
    oc->numVertexFPData	= vertexFPDataSize;
    oc->mPts = colCount;
    oc->nPts = rowCount;
    oc->facetAttribs = facetAttributes;
    oc->vertexAttribs =	vertexAttributes;
    oc->shape =	ocSrc->data.ExtQuadrilateralMesh.shape_hint;
    
    END_ENCODE_OCHEADER	(ExtQuadrilateralMesh, *ocDest,	oc);

    if (facetAttributes)
    {
	STORE_LISTOF_FACET ((rowCount -	1) * (colCount - 1),
	    NUMBYTES (lenofFacet), colorType, facetAttributes,
	    ocSrc->data.ExtQuadrilateralMesh.facet_data,
	    *ocDest, fpConvert,	fpFormat);
    }
    
    STORE_LISTOF_EXT_VERTEX (rowCount *	colCount, NUMBYTES (lenofVertex),
	colorType, vertexFPDataSize,
	vertexAttributes, ocSrc->data.ExtQuadrilateralMesh.vertices,
	*ocDest, fpConvert, fpFormat);
}


void _PEXExtEncodeSOFA (fpFormat, ocSrc, ocDest)

int		fpFormat;
PEXExtOCData	*ocSrc;
char		**ocDest;

{
    pexExtSetOfFillAreaSets	*oc;
    PEXConnectivityData		*pConnectivity;
    PEXListOfUShort		*pList;
    int				lenofColor;
    int				lenofFacet;
    int				lenofVertex;
    int				sizeofEdge;
    int				totLength;
    int				numContours;
    int				count;
    int				i, j;
    unsigned int		facetAttributes;
    unsigned int		vertexAttributes;
    unsigned int		edgeAttributes;
    int				colorType, cbytes;
    int				vertexFPDataSize;
    unsigned int		numFillAreaSets;
    unsigned int		numVertices;
    unsigned int		numIndices;
    int				fpConvert = (fpFormat != NATIVE_FP_FORMAT);
    
    colorType =	ocSrc->data.ExtSetOfFillAreaSets.color_type;
    vertexFPDataSize = ocSrc->data.ExtSetOfFillAreaSets.vertex_fp_data_size;
    facetAttributes = ocSrc->data.ExtSetOfFillAreaSets.facet_attributes;
    vertexAttributes = ocSrc->data.ExtSetOfFillAreaSets.vertex_attributes;
    edgeAttributes = ocSrc->data.ExtSetOfFillAreaSets.edge_attributes;
    numFillAreaSets = ocSrc->data.ExtSetOfFillAreaSets.set_count;
    numVertices	= ocSrc->data.ExtSetOfFillAreaSets.vertex_count;
    numIndices = ocSrc->data.ExtSetOfFillAreaSets.index_count;
    
    numContours	= 0;
    pConnectivity = ocSrc->data.ExtSetOfFillAreaSets.connectivity;
    for	(i = 0;	i < numFillAreaSets; i++, pConnectivity++)
	numContours += pConnectivity->count;
    
    lenofColor = GetColorLength	(colorType);
    lenofFacet = GetFacetDataLength (facetAttributes, lenofColor); 
    lenofVertex	= GetVertexWithDataLength (vertexAttributes, lenofColor);

    if (vertexAttributes & PEXExtGAData)
	lenofVertex += NUMWORDS	(vertexFPDataSize * SIZEOF (PEXFLOAT));

    sizeofEdge = edgeAttributes	? SIZEOF (CARD8) : 0;
    
    cbytes = SIZEOF (CARD16) * (numFillAreaSets	+ numContours +	numIndices);

    totLength =	(lenofFacet * numFillAreaSets) + (lenofVertex *	numVertices) + 
	NUMWORDS (sizeofEdge * numIndices) + NUMWORDS (cbytes);
    
    BEGIN_ENCODE_OCHEADER (ExtSetOfFillAreaSets, ocSrc->oc_type,
	totLength, *ocDest, oc);

    oc->shape =	ocSrc->data.ExtSetOfFillAreaSets.shape_hint;
    oc->colorType = colorType;
    oc->numVertexFPData	= vertexFPDataSize;
    oc->FAS_Attributes = facetAttributes;
    oc->vertexAttributes = vertexAttributes;
    oc->edgeAttributes = edgeAttributes	? PEXOn	: PEXOff;
    oc->contourHint = ocSrc->data.ExtSetOfFillAreaSets.contour_hint;
    oc->contourCountsFlag = ocSrc->data.ExtSetOfFillAreaSets.contours_all_one;
    oc->numFAS = numFillAreaSets;
    oc->numVertices = numVertices;
    oc->numEdges = numIndices;
    oc->numContours = numContours;
    
    END_ENCODE_OCHEADER	(ExtSetOfFillAreaSets, *ocDest,	oc);
  
    if (facetAttributes)
    {
	STORE_LISTOF_FACET (numFillAreaSets, NUMBYTES (lenofFacet), colorType,
	    facetAttributes, ocSrc->data.ExtSetOfFillAreaSets.facet_data,
	    *ocDest, fpConvert,	fpFormat);
    }
    
    STORE_LISTOF_EXT_VERTEX (numVertices, NUMBYTES (lenofVertex), colorType,
	vertexFPDataSize, vertexAttributes, 
	ocSrc->data.ExtSetOfFillAreaSets.vertices,
	*ocDest, fpConvert, fpFormat);

    if (edgeAttributes)
    {
	COPY_AREA (ocSrc->data.ExtSetOfFillAreaSets.edge_flags,
	    *ocDest, numIndices);

	*ocDest	+= PADDED_BYTES	(numIndices);
    }
    
    pConnectivity = ocSrc->data.ExtSetOfFillAreaSets.connectivity;
    
    for	(i = 0 ; i < numFillAreaSets; i++)
    {
	count =	pConnectivity->count;
	STORE_CARD16 (count, *ocDest);

	for (j = 0, pList = pConnectivity->lists; j < count; j++, pList++)
	{
	    STORE_CARD16 (pList->count,	*ocDest);

	    STORE_LISTOF_CARD16	(pList->count, pList->shorts, *ocDest);
	}
	
	pConnectivity++;
    }

    *ocDest += PAD (cbytes);
}


void _PEXExtEncodePrimitiveAA (fpFormat, ocSrc,	ocDest)
int		fpFormat;
PEXExtOCData	*ocSrc;
char		**ocDest;

{
    pexExtPrimitiveAA	*oc;

    BEGIN_SIMPLE_ENCODE	(ExtPrimitiveAA, ocSrc->oc_type, *ocDest, oc);

    oc->mode = ocSrc->data.ExtSetPrimitiveAA.mode;
    oc->blend_op = ocSrc->data.ExtSetPrimitiveAA.blend_op;
    
    END_SIMPLE_ENCODE (ExtPrimitiveAA, *ocDest,	oc);
}


void _PEXExtEncodeEllipse (fpFormat, ocSrc, ocDest)

int		fpFormat;
PEXExtOCData	*ocSrc;
char		**ocDest;

{
    pexExtEllipse	*oc;
    int			fpConvert = (fpFormat != NATIVE_FP_FORMAT);
    

    BEGIN_SIMPLE_ENCODE	(ExtEllipse, ocSrc->oc_type, *ocDest, oc);

    if (fpConvert)
    {
	FP_CONVERT_HTON	(ocSrc->data.ExtEllipse.center.x,
	    oc->center_x, fpFormat);
	FP_CONVERT_HTON	(ocSrc->data.ExtEllipse.center.y,
	    oc->center_y, fpFormat);
	FP_CONVERT_HTON	(ocSrc->data.ExtEllipse.center.z,
	    oc->center_z, fpFormat);
	FP_CONVERT_HTON	(ocSrc->data.ExtEllipse.major.x,
	    oc->major_x, fpFormat);
	FP_CONVERT_HTON	(ocSrc->data.ExtEllipse.major.y,
	    oc->major_y, fpFormat);
	FP_CONVERT_HTON	(ocSrc->data.ExtEllipse.major.z,
	    oc->major_z, fpFormat);
	FP_CONVERT_HTON	(ocSrc->data.ExtEllipse.minor.x,
	    oc->minor_x, fpFormat);
	FP_CONVERT_HTON	(ocSrc->data.ExtEllipse.minor.y,
	    oc->minor_y, fpFormat);
	FP_CONVERT_HTON	(ocSrc->data.ExtEllipse.minor.z,
	    oc->minor_z, fpFormat);
    }
    else
    {
	oc->center_x = ocSrc->data.ExtEllipse.center.x;
	oc->center_y = ocSrc->data.ExtEllipse.center.y;
	oc->center_z = ocSrc->data.ExtEllipse.center.z;
	oc->major_x = ocSrc->data.ExtEllipse.major.x;
	oc->major_y = ocSrc->data.ExtEllipse.major.y;
	oc->major_z = ocSrc->data.ExtEllipse.major.z;
	oc->minor_x = ocSrc->data.ExtEllipse.minor.x;
	oc->minor_y = ocSrc->data.ExtEllipse.minor.y;
	oc->minor_z = ocSrc->data.ExtEllipse.minor.z;
    }

    END_SIMPLE_ENCODE (ExtEllipse, *ocDest, oc);
}


void _PEXExtEncodeEllipse2D (fpFormat, ocSrc, ocDest)

int		fpFormat;
PEXExtOCData	*ocSrc;
char		**ocDest;

{
    pexExtEllipse2D	*oc; 
    int			fpConvert = (fpFormat != NATIVE_FP_FORMAT);
    

    BEGIN_SIMPLE_ENCODE	(ExtEllipse2D, ocSrc->oc_type, *ocDest,	oc);

    if (fpConvert)
    {
	FP_CONVERT_HTON	(ocSrc->data.ExtEllipse2D.center.x,
	    oc->center_x, fpFormat);
	FP_CONVERT_HTON	(ocSrc->data.ExtEllipse2D.center.y,
	    oc->center_y, fpFormat);
	FP_CONVERT_HTON	(ocSrc->data.ExtEllipse2D.major.x,
	    oc->major_x, fpFormat);
	FP_CONVERT_HTON	(ocSrc->data.ExtEllipse2D.major.y,
	    oc->major_y, fpFormat);
	FP_CONVERT_HTON	(ocSrc->data.ExtEllipse2D.minor.x,
	    oc->minor_x, fpFormat);
	FP_CONVERT_HTON	(ocSrc->data.ExtEllipse2D.minor.y,
	    oc->minor_y, fpFormat);
    }
    else
    {
	oc->center_x = ocSrc->data.ExtEllipse2D.center.x;
	oc->center_y = ocSrc->data.ExtEllipse2D.center.y;
	oc->major_x = ocSrc->data.ExtEllipse2D.major.x;
	oc->major_y = ocSrc->data.ExtEllipse2D.major.y;
	oc->minor_x = ocSrc->data.ExtEllipse2D.minor.x;
	oc->minor_y = ocSrc->data.ExtEllipse2D.minor.y;
    }

    END_SIMPLE_ENCODE (ExtEllipse2D, *ocDest, oc);
}


void _PEXExtEncodeCircle2D (fpFormat, ocSrc, ocDest)

int		fpFormat;
PEXExtOCData	*ocSrc;
char		**ocDest;

{
    pexExtCircle2D	*oc; 
    int			fpConvert = (fpFormat != NATIVE_FP_FORMAT);
    

    BEGIN_SIMPLE_ENCODE	(ExtCircle2D, ocSrc->oc_type, *ocDest, oc);

    if (fpConvert)
    {
	FP_CONVERT_HTON	(ocSrc->data.ExtCircle2D.center.x,
	    oc->center_x, fpFormat);
	FP_CONVERT_HTON	(ocSrc->data.ExtCircle2D.center.y,
	    oc->center_y, fpFormat);
	FP_CONVERT_DHTON (ocSrc->data.ExtCircle2D.radius, 
	    oc->radius,	fpFormat);
    }
    else
    {
	oc->center_x = ocSrc->data.ExtCircle2D.center.x;
	oc->center_y = ocSrc->data.ExtCircle2D.center.y;
	oc->radius = ocSrc->data.ExtCircle2D.radius;
    }

    END_SIMPLE_ENCODE (ExtCircle2D, *ocDest, oc);
}


void _PEXExtEncodeEllipticalArc(fpFormat, ocSrc, ocDest)
 
int		fpFormat;
PEXExtOCData	*ocSrc;
char		**ocDest;
 
{
    pexExtEllipticalArc	*oc;
    int			fpConvert = (fpFormat != NATIVE_FP_FORMAT);
 
 
    BEGIN_SIMPLE_ENCODE	(ExtEllipticalArc, ocSrc->oc_type, *ocDest, oc);
 
    if (fpConvert)
    {
	FP_CONVERT_HTON	(ocSrc->data.ExtEllipticalArc.center.x,
	    oc->center_x, fpFormat);
	FP_CONVERT_HTON	(ocSrc->data.ExtEllipticalArc.center.y,
	    oc->center_y, fpFormat);
	FP_CONVERT_HTON	(ocSrc->data.ExtEllipticalArc.center.z,
	    oc->center_z, fpFormat);
	FP_CONVERT_HTON	(ocSrc->data.ExtEllipticalArc.major.x,
	    oc->major_x, fpFormat);
	FP_CONVERT_HTON	(ocSrc->data.ExtEllipticalArc.major.y,
	    oc->major_y, fpFormat);
	FP_CONVERT_HTON	(ocSrc->data.ExtEllipticalArc.major.z,
	    oc->major_z, fpFormat);
	FP_CONVERT_HTON	(ocSrc->data.ExtEllipticalArc.minor.x,
	    oc->minor_x, fpFormat);
	FP_CONVERT_HTON	(ocSrc->data.ExtEllipticalArc.minor.y,
	    oc->minor_y, fpFormat);
	FP_CONVERT_HTON	(ocSrc->data.ExtEllipticalArc.minor.z,
	    oc->minor_z, fpFormat);
	FP_CONVERT_DHTON (ocSrc->data.ExtEllipticalArc.start,
	    oc->start_angle, fpFormat);
	FP_CONVERT_DHTON (ocSrc->data.ExtEllipticalArc.stop,
	    oc->stop_angle, fpFormat);
    }
    else
    {
	oc->center_x = ocSrc->data.ExtEllipticalArc.center.x;
	oc->center_y = ocSrc->data.ExtEllipticalArc.center.y;
	oc->center_z = ocSrc->data.ExtEllipticalArc.center.z;
	oc->major_x = ocSrc->data.ExtEllipticalArc.major.x;
	oc->major_y = ocSrc->data.ExtEllipticalArc.major.y;
	oc->major_z = ocSrc->data.ExtEllipticalArc.major.z;
	oc->minor_x = ocSrc->data.ExtEllipticalArc.minor.x;
	oc->minor_y = ocSrc->data.ExtEllipticalArc.minor.y;
	oc->minor_z = ocSrc->data.ExtEllipticalArc.minor.z;
	oc->start_angle	= ocSrc->data.ExtEllipticalArc.start;
	oc->stop_angle = ocSrc->data.ExtEllipticalArc.stop;
    }
 
    END_SIMPLE_ENCODE (ExtEllipticalArc, *ocDest, oc);
}
 

void _PEXExtEncodeEllipticalArc2D (fpFormat, ocSrc, ocDest)
 
int		fpFormat;
PEXExtOCData	*ocSrc;
char		**ocDest;
 
{
    pexExtEllipticalArc2D	*oc;
    int			fpConvert = (fpFormat != NATIVE_FP_FORMAT);
 
 
    BEGIN_SIMPLE_ENCODE	(ExtEllipticalArc2D, ocSrc->oc_type, *ocDest, oc);
 
    if (fpConvert)
    {
	FP_CONVERT_HTON	(ocSrc->data.ExtEllipticalArc2D.center.x,
	    oc->center_x, fpFormat);
	FP_CONVERT_HTON	(ocSrc->data.ExtEllipticalArc2D.center.y,
	    oc->center_y, fpFormat);
	FP_CONVERT_HTON	(ocSrc->data.ExtEllipticalArc2D.major.x,
	    oc->major_x, fpFormat);
	FP_CONVERT_HTON	(ocSrc->data.ExtEllipticalArc2D.major.y,
	    oc->major_y, fpFormat);
	FP_CONVERT_HTON	(ocSrc->data.ExtEllipticalArc2D.minor.x,
	    oc->minor_x, fpFormat);
	FP_CONVERT_HTON	(ocSrc->data.ExtEllipticalArc2D.minor.y,
	    oc->minor_y, fpFormat);
	FP_CONVERT_DHTON (ocSrc->data.ExtEllipticalArc2D.start,
	    oc->start_angle, fpFormat);
	FP_CONVERT_DHTON (ocSrc->data.ExtEllipticalArc2D.stop,
	    oc->stop_angle, fpFormat);
    }
    else
    {
	oc->center_x = ocSrc->data.ExtEllipticalArc2D.center.x;
	oc->center_y = ocSrc->data.ExtEllipticalArc2D.center.y;
	oc->major_x = ocSrc->data.ExtEllipticalArc2D.major.x;
	oc->major_y = ocSrc->data.ExtEllipticalArc2D.major.y;
	oc->minor_x = ocSrc->data.ExtEllipticalArc2D.minor.x;
	oc->minor_y = ocSrc->data.ExtEllipticalArc2D.minor.y;
	oc->start_angle	= ocSrc->data.ExtEllipticalArc2D.start;
	oc->stop_angle = ocSrc->data.ExtEllipticalArc2D.stop;
    }
 
    END_SIMPLE_ENCODE (ExtEllipticalArc2D, *ocDest, oc);
}
 

void _PEXExtEncodeCircularArc2D	(fpFormat, ocSrc, ocDest)
 
int		fpFormat;
PEXExtOCData	*ocSrc;
char		**ocDest;
 
{
    pexExtCircularArc2D	*oc;
    int			fpConvert = (fpFormat != NATIVE_FP_FORMAT);
 
 
    BEGIN_SIMPLE_ENCODE	(ExtCircularArc2D, ocSrc->oc_type, *ocDest, oc);
 
    if (fpConvert)
    {
	FP_CONVERT_HTON	(ocSrc->data.ExtCircularArc2D.center.x,
	    oc->center_x, fpFormat);
	FP_CONVERT_HTON	(ocSrc->data.ExtCircularArc2D.center.y,
	    oc->center_y, fpFormat);
	FP_CONVERT_DHTON (ocSrc->data.ExtCircularArc2D.radius,
	    oc->radius,	fpFormat);
	FP_CONVERT_DHTON (ocSrc->data.ExtCircularArc2D.start,
	    oc->start_angle, fpFormat);
	FP_CONVERT_DHTON (ocSrc->data.ExtCircularArc2D.stop,
	    oc->stop_angle, fpFormat);
    }
    else
    {
	oc->center_x = ocSrc->data.ExtCircularArc2D.center.x;
	oc->center_y = ocSrc->data.ExtCircularArc2D.center.y;
	oc->radius = ocSrc->data.ExtCircularArc2D.radius;
	oc->start_angle	= ocSrc->data.ExtCircularArc2D.start;
	oc->stop_angle = ocSrc->data.ExtCircularArc2D.stop;
    }
 
    END_SIMPLE_ENCODE (ExtCircularArc2D, *ocDest, oc);
}
 

void _PEXExtEncodeVendorExtOC (ocSrc, ocDest)
			    
PEXExtOCData	*ocSrc;
char		**ocDest;
 
{
    pexExtVendorExtOC	*oc;
    unsigned long	dataLength;

 
    dataLength = NUMWORDS (ocSrc->data.ExtVendorExtOC.length);
    
    BEGIN_ENCODE_OCHEADER (ExtVendorExtOC, ocSrc->oc_type, dataLength, 
			   *ocDest, oc);

    oc->numBytes = ocSrc->data.ExtVendorExtOC.length;
    
    END_ENCODE_OCHEADER	(ExtVendorExtOC, *ocDest, oc);

    COPY_AREA (ocSrc->data.ExtVendorExtOC.data,	*ocDest,
	       ocSrc->data.ExtVendorExtOC.length); 
    *ocDest += PADDED_BYTES (ocSrc->data.ExtVendorExtOC.length);

}
/***** End of Ext section ************/
